const lo = require('lodash');
const hlp = require('../../../helpers')
const hlpPolicy = require('../../../helpers_policy');
const hlpSch = require('./TaskScheduleHelper.js')

const defPolicySections = ['SCPolicy', 'PredefinedTasksPolicy']
const formValues = ['SuspiciousScriptAction', 'UseHeuristicAnalyzer', 'HeuristicAnalyzerLevel', 'UseTrustedZoneSettings']

function toView(TASK_ADDITIONAL_PARAMS, activePolicyCache, formType) {
    if(formType === 'Schedule' ) {
        return hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule, activePolicyCache.PredefinedTasksPolicy.SCTaskStartOptions);
    }
    if(formType!=='Main')
        return {}

    let data = {
        Form_Protection_ScriptCheckerCommon: hlp.localSettingsToView(TASK_ADDITIONAL_PARAMS.Settings,activePolicyCache.SCPolicy,formValues),
    }
    data.Form_Protection_ScriptCheckerCommon.LocalTask = true;
    return data
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule);
        return;
    }
    else if(formType==='Main') {
        const common = hlp.ItemToLocalSettings(changedData.Form_Protection_ScriptCheckerCommon);
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings, lo.pick(common, formValues));
    }
}

function RbacToPolicyCache(activePolicyCache){
    activePolicyCache.SCPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.SCPolicy, formValues);
    activePolicyCache.PredefinedTasksPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.PredefinedTasksPolicy, ['SCTaskStartOptions']);
    return activePolicyCache;
}

module.exports = {
    defPolicySections,
    toView,
    toRaw,
    RbacToPolicyCache
};
