const lo = require('lodash');
const hlp = require('../../../../helpers')
const hlpSchedule = require('../Schedule/schedule.js')

const sections = ['DeviceControlPolicy', 'PredefinedTasksPolicy']
const formValues = ['Mode', 'SetAuditModeOnStop', 'Rules']

function toView (policiesCache) {
    let data = {
        Form_Control_DevCtrlComon: hlp.customToView(policiesCache.DeviceControlPolicy.Policy.KLPRSS_Val, formValues),
        Form_Policy_DcSchedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.DeviceControlStartOptions)
    }
    return data
}

function toRaw (changedData, policiesCache) {
    Object.assign( policiesCache.DeviceControlPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Control_DevCtrlComon, formValues));
    hlpSchedule.toRaw(changedData.Form_Policy_DcSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.DeviceControlStartOptions);
    policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.EnableDeviceGeneratorTasksScheduling.KLPRSS_Mnd = policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.DeviceControlStartOptions.KLPRSS_Mnd;
 //
}

module.exports = {
    sections,
    toView,
    toRaw
};
