const lo = require('lodash');
const hlp = require('../../../../helpers')
const hlpKsn = require('../../../utils/ksn')

const sections = ['KsnServicePolicy']
const formValues = ['ConfirmTermsAndConditions','UseUdsForFiles','UseUdsForUrls','SendStatistics','UseKpsn','UseKmpService']

async function toViewEx(kscApi, policiesCache) {
    let data = hlp.customToView(policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, formValues)
    data.LocEula = await hlpKsn.getKpsnEula(kscApi)
    return data
}

function toRaw (changedData, policiesCache) {
    const useKpsn = changedData.ConfirmTermsAndConditions.KLPRSS_Val[0]
    changedData.UseKpsn.KLPRSS_Val[0] = useKpsn
    changedData.UseUdsForFiles.KLPRSS_Val[0] = useKpsn
    changedData.UseUdsForUrls.KLPRSS_Val[0] = useKpsn
    changedData.SendStatistics.KLPRSS_Val[0] = useKpsn
    changedData.UseKmpService.KLPRSS_Val[0] = useKpsn
    Object.assign( policiesCache.KsnServicePolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toViewEx,
    toRaw
};
