const lo = require('lodash');
const hlp = require('../../../../helpers')
const hlpSchedule = require('../Schedule/schedule.js')

const sections = ['SCPolicy', 'PredefinedTasksPolicy']
const formValues = ['SuspiciousScriptAction', 'UseHeuristicAnalyzer', 'HeuristicAnalyzerLevel', 'UseTrustedZoneSettings']

function toView (policiesCache) {
    let data = {
        Form_Protection_ScriptCheckerCommon: hlp.customToView(policiesCache.SCPolicy.Policy.KLPRSS_Val, formValues),
        Form_Policy_ScSchedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.SCTaskStartOptions)
    }
    return data
//    return hlp.customToView(policiesCache.SCPolicy.Policy.KLPRSS_Val, formValues)
}

function toRaw (changedData, policiesCache) {
    Object.assign( policiesCache.SCPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Protection_ScriptCheckerCommon, formValues));
    hlpSchedule.toRaw(changedData.Form_Policy_ScSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.SCTaskStartOptions);
}

module.exports = {
    sections,
    toView,
    toRaw
};
