const lo    = require('lodash');
const hlp   = require('../../../../helpers')
const hlpSchedule = require('../Schedule/schedule.js')
const utilsFim = require('../../../utils/fim.js')

const sections = ['FileIntegrityMonitor','PredefinedTasksPolicy']
const formValues = ['CheckOfflineChanges','CheckUSNCompromise','MonitorArea']

function toView (policiesCache) {
    let data = {
        Form_SysInspect_FimCommon: hlp.customToView(policiesCache.FileIntegrityMonitor.Policy.KLPRSS_Val, formValues),
        Form_Policy_FimSchedule: hlpSchedule.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.FileIntegrityMonitorStartOptions)
    }
    data.Form_SysInspect_FimCommon = utilsFim.toViewMonitorArea(data.Form_SysInspect_FimCommon);
    return data
}

function toRaw (changedData, policiesCache) {
    const FimCommon = utilsFim.toRowMonitorArea(changedData.Form_SysInspect_FimCommon);
    Object.assign( policiesCache.FileIntegrityMonitor.Policy.KLPRSS_Val, lo.pick(FimCommon, formValues));

    // schedule
    hlpSchedule.toRaw(changedData.Form_Policy_FimSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.FileIntegrityMonitorStartOptions);
}

module.exports = {
    sections,
    toView,
    toRaw
};
