const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['MountDeviceSettings']
const formValues = ['ScanUsbDrive']

function toView (settCache, activePolicyCache) {
    let data = hlp.localSettingsToView(settCache.MountDeviceSettings,activePolicyCache.MountDeviceSettings,formValues)
    data.LocalSettings = true
    let sett = data.ScanUsbDrive.KLPRSS_Val[0]
    if( sett.UseSizeLimit.KLPRSS_Val && sett.SizeLimit.KLPRSS_Val === 0)
        sett.SizeLimit.KLPRSS_Val = 1024
    return data
}

function toRaw (changedData, settCache) {
    hlp.ItemToLocalSettings(changedData);
    let sett = changedData.ScanUsbDrive
    if( sett.UseSizeLimit && sett.SizeLimit === 0)
        sett.SizeLimit = 1024
    Object.assign(settCache.MountDeviceSettings, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
