const lo = require('lodash');
const hlp = require('../../../../helpers');

const sections = ['BLSettings','HSMSettings'];
const formValues = ['UseAutoScalability','ScalabilityProcessCount','ScalabilityProcessCountUsedByRtp', 'ScalabilityLowPriorityProcessCount'];
const formScanValues = ['RestoreFiletimesAfterScan','UseCPURestrictionOnScan','CPURestrictionValue','TemporaryScanFolder'];

function toView (settCache, activePolicyCache) {
    let data = {
        Scalability: hlp.localSettingsToView(settCache.BLSettings,activePolicyCache.BLSettings,formValues),
        Scan: hlp.localSettingsToView(settCache.BLSettings,activePolicyCache.BLSettings,formScanValues),
        HSMPolicy: hlp.localSettingsToView(settCache.HSMSettings,activePolicyCache.HSMSettings,['ActionType']),
        Tray: hlp.GetMergedLocalSettingsKey(settCache.BLSettings,activePolicyCache.BLSettings,'AutoStartTrayIconApplication'),
        LocalSettings:true
    }
    return data;
}

function toRaw (changedData, settCache) {
    hlp.ItemToLocalSettings(changedData.Scalability);
    Object.assign(settCache.BLSettings, lo.pick(changedData.Scalability, formValues));

    hlp.ItemToLocalSettings(changedData.Scan);
    Object.assign(settCache.BLSettings, lo.pick(changedData.Scan, formScanValues));

    settCache.BLSettings.AutoStartTrayIconApplication = changedData.Tray.KLPRSS_Val[0];

    settCache.HSMSettings.ActionType = changedData.HSMPolicy.ActionType.KLPRSS_Val[0];
}

module.exports = {
    sections,
    toView,
    toRaw
};
