const lo = require('lodash');
const hlp = require('../../../../helpers');
const utils  = require('../../../../utils');
const utilsEv = require('../../../utils/events.js');

const sections = ['NotificationSettings'];
const formValues = ['EventsAlertOptions', 'TerminalUsersNotificationTimeout'];

function toView (settCache, activePolicyCache) {
    let data = hlp.localSettingsToView(settCache.NotificationSettings,activePolicyCache.NotificationSettings,formValues);
    data.LocalSettings = true;
    for(let evt of data.EventsAlertOptions.KLPRSS_Val[0]) {
        evt = utilsEv.AlertToView(evt);
    }
    return data;
}

async function toRawEx (kscApi, changedData, settCache) {
    for(let evt of changedData.EventsAlertOptions.KLPRSS_Val[0]) {
        evt = await utilsEv.AlertToRow(kscApi,evt);
        evt = hlp.ItemToLocalSettings(evt);
        evt.AdminNetsendSettings.Recipients = utils.normalizedArrayMasks(evt.uiFields.AdminNetsendRecipients);
        evt.EmailSettings.Recipients = utils.normalizedArrayMasks(evt.uiFields.AdminEmailRecipients);
        delete evt.uiFields;
    }
    changedData = hlp.ItemToLocalSettings(changedData);
    settCache.NotificationSettings.EventsAlertOptions = changedData.EventsAlertOptions;
}

module.exports = {
    sections,
    toView,
    toRawEx
};
