const hlp_t = require('../../../helpers_time.js')

const formValues = ['Enable', 'Frequency',
    'EnableDurationLimit','EnableSuspend','EnableDeactivate','RunMissedTasks','EnableRandomizationPeriod','RandomizationPeriod']

////////////////////////////////////////////////////
function toView (ScheduleData) {
    if(ScheduleData=== undefined )
        return {}
    const uCount = (ScheduleData.UnitCount===0 ) ? 1 : ScheduleData.UnitCount
    let data = {
        nHour: uCount,
        nDay: uCount,
        nWeek: uCount,
        ActivateDate: hlp_t.GetDateUtc(ScheduleData.ActivateTime.value),
        DeactivateTime: hlp_t.GetDateUtc(ScheduleData.DeactivateTime.value),
        StartTime: hlp_t.SecondsToTimeStr(ScheduleData.StartTime),
        SuspendFrom: hlp_t.SecondsToTimeStr(ScheduleData.SuspendFrom),
        SuspendTill: hlp_t.SecondsToTimeStr(ScheduleData.SuspendTill),
        DurationLimit: hlp_t.MinutesToTimeStr(ScheduleData.DurationLimit),
        allScheduleData: ScheduleData
    }

    for (let key of formValues)
        data[key] = ScheduleData[key]

    hlp_t.DaysOfWeektoView(data, ScheduleData.DaysOfWeek)
    return data
}

function toRaw (changedData, ScheduleData) {
    if(ScheduleData=== undefined )
        return

    for (let key of formValues) {
        ScheduleData[key] = changedData[key]
    }

    ScheduleData.DaysOfWeek = hlp_t.DaysOfWeektoRow(changedData)
    ScheduleData.ActivateTime.value = hlp_t.SetDateUtc(changedData.ActivateDate)
    ScheduleData.StartTime= hlp_t.TimeStrToSeconds(changedData.StartTime)

    if(changedData.Frequency=== hlp_t.TaskScheduleFrequencyEnum.Hours )
        ScheduleData.UnitCount = changedData.nHour
    else if(changedData.Frequency=== hlp_t.TaskScheduleFrequencyEnum.Days )
        ScheduleData.UnitCount = changedData.nDay
    else if(changedData.Frequency=== hlp_t.TaskScheduleFrequencyEnum.Weeks )
        ScheduleData.UnitCount = changedData.nWeek

    if(changedData.EnableDeactivate)
        ScheduleData.DeactivateTime.value = hlp_t.SetDateUtc(changedData.DeactivateTime);
    if(changedData.EnableSuspend){
        ScheduleData.SuspendFrom = hlp_t.TimeStrToSeconds(changedData.SuspendFrom)
        ScheduleData.SuspendTill = hlp_t.TimeStrToSeconds(changedData.SuspendTill)
    }
    if(changedData.EnableDurationLimit)
        ScheduleData.DurationLimit = hlp_t.TimeStrToMinutes(changedData.DurationLimit)
}

module.exports = {
    toView,
    toRaw
};
