const hlpSch = require('./TaskScheduleHelper.js')
const utilsUpdate = require('../../utils/update.js')

function toView (TASK_ADDITIONAL_PARAMS, formType) {
    if(formType === 'Schedule' ) {
        let data = hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule);
        data.UpdateBases = true;
        return data;
    }
    else if(formType === 'Main'){
        return utilsUpdate.toFormsUpdateBases(TASK_ADDITIONAL_PARAMS.Settings);
    }
    else if(formType === 'Wizard_Src'){
        return utilsUpdate.toViewUpdateSources(TASK_ADDITIONAL_PARAMS.Settings);
    }
    else if(formType === 'Wizard_Cmn'){
        return utilsUpdate.toViewUpdatebasesCommon(TASK_ADDITIONAL_PARAMS.Settings);
    }
    return {}
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule)
    }
    else if(formType==='Main') {
        TASK_ADDITIONAL_PARAMS.Settings = utilsUpdate.fromFormsUpdateBases(changedData, TASK_ADDITIONAL_PARAMS.Settings);
    }
    else if(formType === 'Wizard_Src'){
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings.CommonSettings.SourceOptions, changedData.SourceOptions);
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings.CommonSettings.ConnectionOptions, changedData.ConnectionOptions);
    }
    else if(formType === 'Wizard_Cmn'){
        TASK_ADDITIONAL_PARAMS.Settings.UseDiskIOOptimization = changedData.UseDiskIOOptimization;
        TASK_ADDITIONAL_PARAMS.Settings.MemoryRequeriedForOptimization = changedData.MemoryRequeriedForOptimization;
    }
}

module.exports = {
    toView,
    toRaw
}
