const lo = require('lodash');
const hlp = require('../../../../helpers')
const utilsAep = require('../../../utils/aep.js')

const sections = ['ExploitBlockerPolicy']
const formCommonValues = ['Enable','Mode','NotifyUser','ProtectAfterServiceStop']
const formProcValues = ['MitigationTechnics']

function toView (policiesCache) {
    let data = {
        Form_Protection_AEPCommon: hlp.customToView(policiesCache.ExploitBlockerPolicy.Policy.KLPRSS_Val, formCommonValues),
        Form_Protection_AEPProcesses: hlp.customToView(policiesCache.ExploitBlockerPolicy.Policy.KLPRSS_Val, formProcValues),
    }
    data.Form_Protection_AEPProcesses = utilsAep.toViewMitigationTechnics(data.Form_Protection_AEPProcesses);
    return data;
}

function toRaw (changedData, policiesCache) {
    Object.assign( policiesCache.ExploitBlockerPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Protection_AEPCommon, formCommonValues));
    // process
    changedData.Form_Protection_AEPProcesses = utilsAep.toRowMitigationTechnics(changedData.Form_Protection_AEPProcesses);
    Object.assign( policiesCache.ExploitBlockerPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Protection_AEPProcesses, formProcValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
