const lo = require('lodash');
const hlp = require('../../../../helpers')
const utilsAep = require('../../../utils/aep.js')

const sections = ['ExploitBlockerSettings']
const formCommonValues = ['Enable','Mode','NotifyUser','ProtectAfterServiceStop']
const formProcValues = ['MitigationTechnics']

function toView(settCache, activePolicyCache) {
    let data = {
        Form_Protection_AEPCommon: hlp.localSettingsToView(settCache.ExploitBlockerSettings,activePolicyCache.ExploitBlockerSettings,formCommonValues),
        Form_Protection_AEPProcesses: hlp.localSettingsToView(settCache.ExploitBlockerSettings,activePolicyCache.ExploitBlockerSettings, formProcValues),
    }
    data.Form_Protection_AEPProcesses = utilsAep.toViewMitigationTechnics(data.Form_Protection_AEPProcesses);
    data.Form_Protection_AEPCommon.LocalSettings = true;
    data.Form_Protection_AEPProcesses.LocalSettings = true;
    return data
}

function toRaw(changedData, settCache) {
    // common
    const Common = hlp.ItemToLocalSettings(changedData.Form_Protection_AEPCommon);
    Object.assign(settCache.ExploitBlockerSettings, lo.pick(Common, formCommonValues));

    // process
    changedData.Form_Protection_AEPProcesses = utilsAep.toRowMitigationTechnics(changedData.Form_Protection_AEPProcesses);
    const Processes = hlp.ItemToLocalSettings(changedData.Form_Protection_AEPProcesses);
    Object.assign(settCache.ExploitBlockerSettings, lo.pick(Processes, formProcValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
